VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form frmConvert 
   Caption         =   "Converter"
   ClientHeight    =   5025
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   5880
   LinkTopic       =   "Form2"
   ScaleHeight     =   5025
   ScaleWidth      =   5880
   StartUpPosition =   3  'Windows Default
   Begin VB.ListBox lstLog 
      Height          =   1035
      Left            =   120
      TabIndex        =   4
      Top             =   3000
      Width           =   5415
   End
   Begin MSComDlg.CommonDialog CommonDialog1 
      Left            =   3360
      Top             =   1800
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
      DefaultExt      =   "ASM"
      DialogTitle     =   "Select ASM file"
      Filter          =   "*.asm|*.asm"
   End
   Begin VB.CommandButton cmdConvert 
      Caption         =   "Convert"
      Height          =   495
      Left            =   3240
      TabIndex        =   3
      Top             =   4320
      Width           =   1215
   End
   Begin VB.CommandButton cmdAdd 
      Caption         =   "Add"
      Height          =   495
      Left            =   1200
      TabIndex        =   2
      Top             =   4320
      Width           =   1215
   End
   Begin VB.ListBox lstFiles 
      Height          =   2205
      Left            =   120
      TabIndex        =   1
      Top             =   600
      Width           =   5415
   End
   Begin VB.Label Label1 
      Caption         =   "Files"
      Height          =   255
      Left            =   120
      TabIndex        =   0
      Top             =   240
      Width           =   1935
   End
End
Attribute VB_Name = "frmConvert"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Added by M.C.Alberts, MCS Electronics
'this is just some minimal code
'typical you would check for double entries when adding files
'also an option to remove a file would be convenient
'and saving/restoring the lstFiles content would be nice
Private Sub cmdAdd_Click()
  CommonDialog1.Action = 1
  If CommonDialog1.CancelError = False Then
     lstFiles.AddItem (CommonDialog1.Filename)
  End If
End Sub
'function to create hex string out of an integer with specified length
Function hx(ByVal L As Long, ByVal i As Integer) As String
  s = "00000000" & Hex(L)
  hx = Right(s, i)
End Function

'check if a number is odd or even
Function IsOdd(ByVal L As Long) As Boolean
  If (L And 1) = 1 Then 'if LS bit is set
     IsOdd = True  'off number like 1,3 etc
  Else
     IsOdd = False 'must be 0,2,4 etc
  End If
End Function
'create Checksum
Function check(ByVal s As String) As String
 Dim j As Integer, v As Integer, tmp As String
 check = s
 s = Mid(s, 2): v = 0
 For j = 1 To Len(s) / 2
   tmp = Mid(s, (j * 2) - 1, 2)
   v = v - Val("&H" + tmp)
   If v < 0 Then v = v + 256
 Next
 check = check + hx(v, 2)
End Function
Private Sub cmdConvert_Click()
  'create an HEX file out of all selected asm files
  Dim sFileOut As String
  Dim ff As Integer, j As Integer, k As Integer, sFile As String
  Dim sLine As String, m As Integer
  Dim binData(128) As String 'storage for DB data
  Dim binLabel(128) As String 'store label name not used
  
  Dim ar() As String 'temp line data
  Dim arB() As String 'tmep DB data
  
  lstLog.Clear
  sFileOut = lstFiles.List(0) 'we use the first one for output file
  sFileOut = Left(sFileOut, Len(sFileOut) - 3) + "HEX"
  
  For j = 0 To lstFiles.ListCount - 1
    ff = FreeFile()
    binData(j) = "" 'clear data

    sFile = lstFiles.List(j)
    Open sFile For Input As #ff 'open file
    Line Input #ff, sLine
    Close #ff
    ar() = Split(sLine, Chr(10))
    For k = 1 To UBound(ar)
      sLine = Trim(ar(k)) 'remove space
      If Left(sLine, 1) = ";" Then
          'comment
      ElseIf InStr(sLine, ":") > 0 Then 'labe;
          binLabel(j) = Left(sLine, Len(sLine) - 1) 'label name
      ElseIf Left(sLine, 3) = "DB " Then 'data
          arB() = Split(Mid(sLine, 3), ",") 'split data
          For m = 0 To UBound(arB)
             binData(j) = binData(j) & Chr(Val(arB(m))) 'add binary data
          Next
      Else 'blank line
      End If
    Next
  Next
  'now we end up with a number of binary strings
  'they need to start on an even address
  Dim lTotal As Long, lOfs As Long
  Dim Header(128) As Long  'header data
  lOfs = 0
  For j = 0 To lstFiles.ListCount - 1
      If IsOdd(Len(binData(j))) Then   'odd
          binData(j) = binData(j) + Chr(0) 'add a nul byte
      End If
      If j = 0 Then
         Header(j) = lstFiles.ListCount 'num of files
      Else
         Header(j) = (lTotal + (Header(0) * 2)) \ 2
      End If
      lTotal = lTotal + Len(binData(j))
      
      lstLog.AddItem "Offset : " + Hex(Header(j))
  Next
  'now all is prepared
  lstLog.AddItem "Total size :$" + Hex(lTotal)
  'layout of intel hex record
  ':10 0000 00 04 00 2C 0D 16 22 F6 31 1A 4E 55 55 55 55 55 55 EE
  
  Open sFileOut For Output As #ff
  Dim sData As String
  sData = ""
  'make the header
  For j = 0 To lstFiles.ListCount - 1
    sData = sData + Chr(Header(j) And 255) + Chr(Header(j) \ 256)
  Next
  'add the data
  For j = 0 To lstFiles.ListCount - 1 'build 1 big string
    sData = sData + binData(j)
  Next
  
  sLine = ""
  For j = 1 To Len(sData) 'for all bytes
     sLine = sLine + hx(Asc(Mid(sData, j, 1)), 2)
     If Len(sLine) = 32 Then '16 bytes of data on a line
        sLine = ":" + hx(16, 2) + hx(address, 4) + "00" + sLine
        address = address + 16
        sLine = check(sLine)
        lstLog.AddItem sLine
        Print #ff, sLine
        sLine = ""
     End If
  Next
  If Len(sLine) > 0 Then 'some left
     sLine = ":" + hx(Len(sLine) \ 2, 2) + hx(address, 4) + "00" + sLine
     sLine = check(sLine)
     Print #ff, sLine
     lstLog.AddItem sLine
  End If
  sLine = ":00000001FF"
  Print #ff, sLine
  lstLog.AddItem sLine
  Close #ff
End Sub


