VERSION 5.00
Object = "{F2F30570-0799-43CA-8CCA-0A7AAD89C3DD}#1.0#0"; "MCSCOMM.OCX"
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "comdlg32.ocx"
Begin VB.Form Form1 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "i2c Eeprom programmer  Evertdekker.com 2008"
   ClientHeight    =   3030
   ClientLeft      =   45
   ClientTop       =   435
   ClientWidth     =   5250
   Icon            =   "EepromProgrammer.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3030
   ScaleWidth      =   5250
   StartUpPosition =   2  'CenterScreen
   Begin mcscomm.CommX CommX1 
      Height          =   495
      Left            =   360
      TabIndex        =   0
      Top             =   4320
      Visible         =   0   'False
      Width           =   1095
      Object.Visible         =   -1  'True
      AutoScroll      =   0   'False
      AutoSize        =   0   'False
      Caption         =   "CommX"
      Color           =   -2147483633
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      KeyPreview      =   0   'False
      PixelsPerInch   =   96
      Scaled          =   -1  'True
      DropTarget      =   0   'False
      HelpFile        =   ""
      DoubleBuffered  =   0   'False
      Enabled         =   -1  'True
      Cursor          =   0
      COMPORT         =   1
      BAUDRATE        =   19200
   End
   Begin VB.Timer Timer1 
      Left            =   4560
      Top             =   2760
   End
   Begin VB.ComboBox ComboBaud 
      Height          =   315
      ItemData        =   "EepromProgrammer.frx":014A
      Left            =   120
      List            =   "EepromProgrammer.frx":0160
      Style           =   2  'Dropdown List
      TabIndex        =   7
      Top             =   1200
      Width           =   1575
   End
   Begin VB.ComboBox ComboComport 
      Height          =   315
      ItemData        =   "EepromProgrammer.frx":018C
      Left            =   120
      List            =   "EepromProgrammer.frx":01A2
      Style           =   2  'Dropdown List
      TabIndex        =   6
      Top             =   720
      Width           =   1575
   End
   Begin VB.CommandButton BtOpenComm 
      Caption         =   "&Open comm"
      Height          =   375
      Left            =   3720
      TabIndex        =   5
      Top             =   720
      Width           =   1215
   End
   Begin VB.CommandButton BtStart 
      Caption         =   "&Start"
      Enabled         =   0   'False
      Height          =   375
      Left            =   3720
      TabIndex        =   4
      Top             =   1200
      Width           =   1215
   End
   Begin VB.CommandButton Command1 
      Caption         =   "="
      Height          =   285
      Left            =   4440
      TabIndex        =   3
      Top             =   240
      Width           =   495
   End
   Begin VB.TextBox Text2 
      Height          =   285
      Left            =   120
      TabIndex        =   2
      Text            =   "Choose your eeprom file"
      Top             =   240
      Width           =   4215
   End
   Begin VB.TextBox Text1 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   975
      Left            =   120
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      TabIndex        =   1
      Top             =   1800
      Width           =   4935
   End
   Begin MSComDlg.CommonDialog CommonDialog1 
      Left            =   1680
      Top             =   4320
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
      Filter          =   "Hex (*.Hex)|*.Hex|"
   End
   Begin VB.Label Label3 
      Caption         =   "Ver 1.00 24-2-2008"
      BeginProperty Font 
         Name            =   "MS Serif"
         Size            =   6
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   135
      Left            =   120
      TabIndex        =   10
      Top             =   2880
      Width           =   1695
   End
   Begin VB.Label Label2 
      Caption         =   "Baudrate"
      Height          =   255
      Left            =   1800
      TabIndex        =   9
      Top             =   1200
      Width           =   735
   End
   Begin VB.Label Label1 
      Caption         =   "Port"
      Height          =   255
      Left            =   1800
      TabIndex        =   8
      Top             =   840
      Width           =   615
   End
   Begin VB.Shape LedOpen 
      FillColor       =   &H00E0E0E0&
      FillStyle       =   0  'Solid
      Height          =   375
      Left            =   3360
      Shape           =   3  'Circle
      Top             =   720
      Width           =   255
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Public PortIsopen As Boolean     'Dim some global variable
Public Ack As Boolean
Public Nack As Boolean
Public Retry As Byte

Private Sub BtOpenComm_Click()              'Open the commport
 If PortIsopen = False Then                 'McsComm from Mcselec is used, this control will NOT give a error if the port not exist of will not open
    CommX1.BAUDRATE = Val(ComboBaud)
    CommX1.COMPORT = Val(ComboComport)
    CommX1.OPEN
    LedOpen.FillColor = vbGreen
    BtOpenComm.Caption = "&Close"
    PortIsopen = True
 Else
    CommX1.Close
    LedOpen.FillColor = &HE0E0E0
    BtOpenComm.Caption = "&Open"
    PortIsopen = False
 End If
End Sub

Private Sub ComboBaud_Click()               'Save the changed setting
SaveSetting "Evert", "EepromProgrammer", "CommBaud", ComboBaud
End Sub

Private Sub ComboComport_Click()            'Save the changed setting
SaveSetting "Evert", "EepromProgrammer", "Commport", ComboComport
End Sub

Private Sub Command1_Click()                'Select the filename
CommonDialog1.ShowOpen
Text2.Text = CommonDialog1.Filename
End Sub

Private Sub BtStart_Click()
Open Text2.Text For Input As #1             'Open the Eeprom file
BtStart.Enabled = False
Send_Data                                   'Goto the Send_data routine
End Sub


Private Sub Send_Data()
Do Until EOF(1)                             'Do until the end of the Eeprom file
 Input #1, Regel                            'Read 1 line from the file
 Retry = 0                                  'First try
Send:
 Text1 = Regel                              'Show us something to watch
 Ack = False: Nack = False                  'Reset Nack and Ack flag
 CommX1.Send Regel & vbCr                   'Send the line out the commport incl. carriage return
    Timer1.Interval = 100: Timer1.Enabled = True 'Start the timeout timer
    Do                                      'Do nothing until there's a Ack or nack
     DoEvents                               'Give cpu time back
    Loop Until Ack = True Or Nack = True
If Nack = True Then                         'Nack received lets try it again
    Retry = Retry + 1                       'Incr retry counter
     If Retry > 5 Then                      'To many retry's
        Beep
        Text1 = Text1 & vbCrLf & "ABORT To many retry's"
        Close #1                            'Close the Eeprom file
        Exit Sub                            'Going out of here
     End If
    GoTo Send                               'Retry, so jumpp back to starting point sending
End If
Timer1.Enabled = False                      'Received Ack, timeout timer must be stopped
Loop                                        'Give me the next line from the eeprom file
Close #1                                    'Done everything bye, bye
Text1 = Text1 & vbCrLf & "Ready, thanks have a nice day."
End Sub


Private Sub CommX1_OnReceive(ByVal DATA As String)
  Select Case DATA
  Case Is = "Y"                             'Y stands for ACK
   Ack = True: Nack = False
  Case Is = "Z"                             'Z stands for NACK
   Nack = True: Ack = False
  Case Else                                 'Everything else is nothing
   Nack = True: Ack = False
  End Select
End Sub

Private Sub Text1_Change()
Text1.SetFocus
Text1.SelStart = Len(Text1.Text)
End Sub

Private Sub Text2_Change()                  'Check of the selected eeprom file really exists
If FileExists(Text2) Then
    BtStart.Enabled = True
    Else
    BtStart.Enabled = False
End If
End Sub

Private Sub Form_Load()                     'Read the setting back from the registry
ComboComport = GetSetting("Evert", "EepromProgrammer", "Commport", 1)
ComboBaud = GetSetting("Evert", "EepromProgrammer", "CommBaud", 19200)
End Sub
Function FileExists(Filename As String) As Boolean
  On Error GoTo ErrorHandler
  ' get the attributes and ensure that it isn't a directory
  FileExists = (GetAttr(Filename) And vbDirectory) = 0
ErrorHandler:
  ' if an error occurs, this function returns False
End Function

Private Sub Timer1_Timer()
 Nack = True                                'Timeout time reached, force Nack for retry
End Sub
